! all the interfaces for the 'misc' units
module misc_interface
  interface 
     subroutine error(code)
       integer,intent(in) :: code
     endsubroutine error
     function get_fileunit() result(fileunit)
       integer :: fileunit
     endfunction get_fileunit
     function get_params_nb(filename) result(n)
       character(len=*),intent(in) :: filename
       integer :: n
     endfunction get_params_nb
     function c_get_param(filename,n) result(p)
       character(len=80) :: p 
       character(len=*),intent(in) :: filename
       integer,intent(in) :: n
     endfunction c_get_param
     function i_get_param(filename,n) result(p)
       integer :: p 
       character(len=*),intent(in) :: filename
       integer,intent(in) :: n
     endfunction i_get_param
     function rhs(n)
       integer, intent(in) :: n
       real(kind(0.d0)),dimension(n) :: rhs
     endfunction rhs
     subroutine r_vect_alloc(v,n)
       real(kind(0.d0)),allocatable,dimension(:),intent(out) :: v
       integer,intent(in) :: n
     endsubroutine r_vect_alloc
     subroutine r_mat_alloc(a,n)
       real(kind(0.d0)),allocatable,dimension(:,:),intent(out) :: a
       integer,intent(in) :: n
     endsubroutine r_mat_alloc
     subroutine i_vect_alloc(v,n)
       integer,allocatable,dimension(:),intent(out) :: v
       integer,intent(in) :: n
     endsubroutine i_vect_alloc
     function rel_err(y,x) result(z)
       real(kind(0.d0)),allocatable,dimension(:) :: z
       real(kind(0.d0)),dimension(:),intent(in) :: y,x
     endfunction rel_err



!!$     subroutine inv_gj(a)
!!$       real (kind(0.d0)),dimension(:,:), intent(inout) :: a 
!!$     endsubroutine inv_gj
!!$     function unity_diff(a) result(d)
!!$       real(kind(0.d0)) :: d 
!!$       real(kind(0.d0)),dimension(:,:),intent(in) :: a
!!$     endfunction unity_diff
!!$     function maxmin_rel_diff(y,x) result(d)
!!$       real(kind(0.d0)),dimension(2) :: d
!!$       real(kind(0.d0)),dimension(:),intent(in) :: y,x
!!$     endfunction maxmin_rel_diff

  endinterface
endmodule misc_interface
