! gauss_st résout le système ax=b par Gauss avec choix du pivot
! en controlant les donnees avec CADNA
! - in
! * n : dimension du systeme
! - inout
! * a et b : matrices du systeme
! - out
! * det : déterminant de a
!
subroutine gauss_st(a,b,n,det)
  use cadna
  implicit none
  integer,intent(in) :: n
  type(double_st),dimension(n,n),intent(inout) :: a
  type(double_st),dimension(n),intent(inout) :: b
  type(double_st),intent(out) :: det

  type(double_st) :: aux
  integer :: i,j,ll,k

  det=1.
  do i=1,n-1
     ll=i
     aux=0.
     do k=i,n
        ! possibilite de test instable
        if (abs(a(k,i)).ge.aux) then
           aux=abs(a(k,i))
           ll=k
        endif
     enddo
     if (ll.ne.i) then
        do j=i,n
           aux=a(i,j)
           a(i,j)=a(ll,j)
           a(ll,j)=aux
        enddo
        aux=b(i)
        b(i)=b(ll)
        b(ll)=aux
     endif
     aux=1./a(i,i)
     det=det/aux
     do j=i+1,n
        a(i,j)=a(i,j)*aux
     enddo
     b(i)=b(i)*aux
     do k=i+1,n
        aux=a(k,i)
        do j=i+1,n
           ! possibilite de perte de precision
           a(k,j)=a(k,j)-aux*a(i,j)
        enddo
        ! possibilite de perte de precision
        b(k)=b(k)-aux*b(i)
     enddo
  enddo
  i=n
  b(n)=b(n)/a(n,n)
  do i=n-1,1,-1
     do j=i+1,n
        ! possibilite de perte de precision
        b(i)=b(i)-a(i,j)*b(j)
     enddo
  enddo

return
endsubroutine gauss_st

      
                                                                             
